/*
 *	bcNAj󂪐iłȂԂŎsB
 */

#include "mytypes.h"
#include "gpupkt.h"
#include "comms.h"
#include "validaddr.h"
#include "hexdump.h"
#include "r3000dis.h"
#include "menuwin.h"

#define HD_STRVERSION	"0.7"

static void InitAll(void);
static void HexDump(void);
static int	doHexDump(void);
static int	doDisasm(void);
static int	doChat(void);
static int doFunctions(void);
static ulong searchPrev(ulong word);
static ulong searchNext(ulong word);

static void LoadMain(void);


volatile uchar PadBuf[12];
enum {
	UNDEF = 0,
	HEXDUMP, ASSEMBLY, FUNCTIONS, CONTROLLEDBY_PC
} DispMode = HEXDUMP;
ulong DispAddress = 0x1f000000;
ulong SearchWord = 0x00000000;
/*
 *	DispAddress ̎肤͈
 *
 *	1f000000-1f07ffff
 *	1f800000-1f8003ff
 *	00000000-801fffff
 *	ȏ̂̂ 80000000  OR ́B
 *  a0000000-a01fffff
 *	bfc00000-bfcfffff (80000  00000 ̃~[)
 *
 *	bf800000-bf8003ff ̓AhXOɂȂ܂B
 */
 
int CurrentFrame = 1;	/* 01 */
#define OFFSCREEN_Y()	( (CurrentFrame << 8) + (IS_SCEE() << 3) )
#define ONSCREEN_Y()	( ((CurrentFrame ^ 1) << 8) + (IS_SCEE() << 3) )
#define TOGGLE_SCREEN()	{ CurrentFrame ^= 1; }

int main(int argc, char **argv)
{
	int wait;
	int c;
	InitAll();
#if 0	/* COPY AR IMAGE TO 80040000 */
	{
		ushort *ptr = (ushort *)0x80040000;
		ushort s, rev;
		/* TEST */
		for (s = 0x8000 ; s != 0x0000 ; s += 1) {
			rev = (s >> 8) | (s << 8);
			*ptr ++ = rev;
		}
	}

	HANIMAR UTILITIES. Relase 0.6
	   : HEX/ASM Viewer
	START: ENTER MAIN MENU
#endif

	GPU_sync();
	bogoVSyncWait2(PadBuf, 4);
#if 0
/*************************************************/
	sendGPU(0x03000000, true);	/* ʕ\ */
	FontPuts("HANIMAR UTILITIES. Release 0.6",
		MKRGB15(0xff, 0xff, 0xff), MKRGB15(0, 0, 0),
		MKSHORT_YX(8+(120 - 48) , (368-30*8)>>1)
		);

	FontPuts("䑡o[Wi񔄕ij",
		MKRGB15(0xff, 0xff, 0x00), MKRGB15(0, 0, 0),
		MKSHORT_YX(8+(120 - 32) , (368-30*8)>>1)
		);


	FontPuts("   : HEX/ASM Viewer",
		MKRGB15(0xff, 0xff, 0xff), MKRGB15(0, 0, 0),
		MKSHORT_YX(8+(120) , (368-22*8)>>1)
		);
	FontPuts("START: ENTER MAIN MENU",
		MKRGB15(0xff, 0xff, 0xff), MKRGB15(0, 0, 0),
		MKSHORT_YX(8+(120 + 16), (368-22*8)>>1)
		);
	FontPuts("Now you can flash ROM or download RAM/ROM.",
		MKRGB15(0xff, 0xff, 0xff), MKRGB15(0, 0, 0),
		MKSHORT_YX(8+(180 + 16), (368-42*8)>>1)
		);
	GPU_sync();
/*********************************************************/
#endif

	CD_Control(7);	/* Standby */

/*********************************************************/
#if 0
	for (;;) {
		bogoVSyncWait2(PadBuf, 1);
		c = CheckComms();
		if (c == 'W') {
			ChatComms_W();
		} else if (c == 'i') {
			ChatComms_i();
		}
		if (PADIS_START(PadBuf)) {
			break;
		}
		if (PADIS_CIRCLE(PadBuf)) {
			HexDump();
			break;
		}
	}
#endif
/*********************************************************/
	HexDump();
	LoadMain();
	return 0;
}
/*
 *	16iAAZu\
 */
static void HexDump(void)
{
	int rc;
	
	rc = DispMode;
	do {
		sendGPU(0x03000001, true);	/* ʔ\ */
		ClearScreen(MKRGB24(0,0,0));	/* t[obt@̑| */
		
		switch (rc) {
		case HEXDUMP:
			rc = doHexDump();
			break;
		case ASSEMBLY:
			rc = doDisasm();
			break;
		case CONTROLLEDBY_PC:
//			rc = doChat();
			rc = DispMode;
			break;
		case FUNCTIONS:
			rc = doFunctions();
			break;
			
		case UNDEF:
		default:
			break;
		}
	} while (rc > 0);
	return;
}

static int	doHexDump(void)
{
	RECT rect;
	int rc = UNDEF;
	ushort fg = MKRGB15(0xc0, 0xc0, 0xc0);
	ushort bg = MKRGB15(0x00, 0x00, 0x00);
	char buf[45 * 4 + 1]; /* (1 + 32 + 1 + "\r\n") * 4 + nul */
	int i, j;
	int KanjiMode = 1;	/* 16i\\bANK \ */
	ulong addr;

	uchar oldBuf[4];
	int keyWait = 0;
#define KEYWAIT_NUM	8

	FontPuts("SEL:DISASM   FDISABLE KANJI   FMENU", 
		MKRGB15(0x00, 0x80, 0x00), MKRGB15(0x0, 0x0, 0x0),
		MKSHORT_YX(212 + OFFSCREEN_Y() , 12)
		);
	FontPuts("SEL:DISASM   FDISABLE KANJI   FMENU", 
		MKRGB15(0x00, 0x80, 0x00), MKRGB15(0x0, 0x0, 0x0),
		MKSHORT_YX(212 + ONSCREEN_Y() , 12)
		);
	sendGPU(0x03000000, true);	/* ʕ\ */
	while (rc == UNDEF) {
		memcpy(oldBuf, (uchar *)PadBuf, sizeof (oldBuf));
		rect.x = 0;
		rect.y = OFFSCREEN_Y();
		rect.w = 368;
		rect.h = 208;
		
		FillRect(&rect, 0);
		XdumpSetup(20, OFFSCREEN_Y() + 40, fg,  bg);
		XdumpSetup(20, OFFSCREEN_Y() + 40 + 12*4, fg,  bg);

		Xdump(DispAddress, DispAddress,
			20, OFFSCREEN_Y() + 40, fg,  bg
			);
		Xdump(DispAddress + 0x40, DispAddress + 0x40,
			20, OFFSCREEN_Y() + 40 + 12*4, fg,  bg
			);


		i = 0;
		for (j = 0 ; j < 0x80 ; j += 0x20) {
			mkLongHex(&buf[i], DispAddress + j);
			buf[i + 8] = ':';
			MakePrintable(&buf[i + 9], DispAddress + j, KanjiMode);
			buf[i + 43] = '\r';
			buf[i + 44] = '\n';
			i += 45;
		}
		buf[i] = '\0';
		FontPuts(buf, 
			MKRGB15(0xff, 0xff, 0xff), MKRGB15(0x0, 0x0, 0x0),
			MKSHORT_YX(140 + OFFSCREEN_Y() , 12)
			);
		sendGPU(0x05000000 | 0 | (OFFSCREEN_Y()) << 10, true);
		TOGGLE_SCREEN();
		GPU_sync();
		bogoVSyncWait2(PadBuf, 1);
		KanjiMode = 1;

		if (CheckComms() == 'i') {
			doChat();
			continue;
		}
		else if (PADIS_SELECT(PadBuf)) {
			while (PADIS_SELECT(PadBuf));
			rc = DispMode = ASSEMBLY;
		}
		else if (PADIS_DOWN(PadBuf)) {
			if (keyWait == 0) {
				DispAddress = MoveAddr(DispAddress, 0x20, 0x80);
				if (!PADIS_DOWN(oldBuf)) keyWait = KEYWAIT_NUM;
			} else keyWait --;
		}
		else if (PADIS_UP(PadBuf)) {
			if (keyWait == 0) {
				DispAddress = MoveAddr(DispAddress, -0x20, 0x80);
				if (!PADIS_UP(oldBuf)) keyWait = KEYWAIT_NUM;
			} else keyWait --;
		}
		else if (PADIS_RIGHT(PadBuf)) {
			if (keyWait == 0) {
				DispAddress = MoveAddr(DispAddress, 0x80, 0x80);
				if (!PADIS_RIGHT(oldBuf)) keyWait = KEYWAIT_NUM;
			} else keyWait --;
		}
		else if (PADIS_LEFT(PadBuf)) {
			if (keyWait == 0) {
				DispAddress = MoveAddr(DispAddress, -0x80, 0x80);
				if (!PADIS_LEFT(oldBuf)) keyWait = KEYWAIT_NUM;
			} else keyWait --;
		} else if (PADIS_L1(PadBuf)) {
			DispAddress = MoveAddr(DispAddress, -0x1000, 0x80);
		} else if (PADIS_R1(PadBuf)) {
			DispAddress = MoveAddr(DispAddress, 0x1000, 0x80);
		} else if (PADIS_CIRCLE(PadBuf)) {
			KanjiMode = 0;
		} else if (PADIS_TRIANGLE(PadBuf)) {
			rc = FUNCTIONS;
		} else if (PADIS_R2(PadBuf)) {
			if (!PADIS_R2(oldBuf)) {
				addr = searchNext(SearchWord);
				if (addr != 0xffffffff) DispAddress = addr;
			}
		} else if (PADIS_L2(PadBuf)) {
			if (!PADIS_L2(oldBuf)) {
				addr = searchPrev(SearchWord);
				if (addr != 0xffffffff) DispAddress = addr;
			}
		} else keyWait = 0;
	}
	return rc;
}
static int	doDisasm(void)
{
	char buf[64];
	ulong addr;
	int line;
	int rc = UNDEF;
	RECT rect;
	uchar oldBuf[4];
	int keyWait = 0;
/* #define KEYWAIT_NUM	8 */
	
	sendGPU(0x03000000, true);	/* ʕ\ */
	while (rc == UNDEF) {
		memcpy(oldBuf, (uchar *)PadBuf, sizeof (oldBuf));
		
		rect.x = 0;
		rect.y = OFFSCREEN_Y();
		rect.w = 368;
		rect.h = 256;
		
		FillRect(&rect, 0);
		addr = DispAddress;
		for (line = 0 ; line < 12 ; line ++) {
			if (IsAddrValid(addr)) {
				R3000dis(addr, *(ulong *)addr,  buf);
				FontPuts(buf, 
					MKRGB15(0xff, 0xff, 0xff), MKRGB15(0, 0, 0),
					MKSHORT_YX(8+24+16*line + OFFSCREEN_Y() , 20)
					);
				GPU_sync();
			}
			addr += 4;
		}
		bogoVSyncWait2(PadBuf, 1);
		sendGPU(0x05000000 | 0 | (OFFSCREEN_Y()) << 10, true);
		TOGGLE_SCREEN();
		GPU_sync();
		
		if (CheckComms() == 'i') {
			doChat();
			continue;
		} else if (PADIS_SELECT(PadBuf)) {
			while (PADIS_SELECT(PadBuf));
			rc = DispMode = HEXDUMP;
		} else if (PADIS_DOWN(PadBuf)) {
			if (keyWait == 0) {
				DispAddress = MoveAddr(DispAddress, 4, 12);
				if (!PADIS_DOWN(oldBuf)) keyWait = KEYWAIT_NUM;
			} else keyWait --;
		} else if (PADIS_UP(PadBuf)) {
			if (keyWait == 0) {
				DispAddress = MoveAddr(DispAddress, -4, 12);
				if (!PADIS_UP(oldBuf)) keyWait = KEYWAIT_NUM;
			} else keyWait --;
		} else if (PADIS_RIGHT(PadBuf)) {
			if (keyWait == 0) {
				DispAddress = MoveAddr(DispAddress, 48, 12);
				if (!PADIS_RIGHT(oldBuf)) keyWait = KEYWAIT_NUM;
			} else keyWait --;
		} else if (PADIS_LEFT(PadBuf)) {
			if (keyWait == 0) {
				DispAddress = MoveAddr(DispAddress, -48, 12);
				if (!PADIS_LEFT(oldBuf)) keyWait = KEYWAIT_NUM;
			} else keyWait --;
		} else if (PADIS_TRIANGLE(PadBuf)) {
			rc = FUNCTIONS;
		} else if (PADIS_R2(PadBuf)) {
			addr = searchNext(SearchWord);
			if (addr != 0xffffffff) DispAddress = addr;
		} else if (PADIS_L2(PadBuf)) {
			addr = searchPrev(SearchWord);
			if (addr != 0xffffffff) DispAddress = addr;
		} else keyWait = 0;
	}
	return rc;
}
static int doChat(void)
{
	ulong cop0_12;
	RECT rect = {
		0, ONSCREEN_Y(), 368, 256
	};
	
	CopyImage(&rect, 0, OFFSCREEN_Y());
	GPU_sync();
	FontPuts(" PC is in control... ", /* 21bytes */
		MKRGB15(0x0, 0x0, 0x0), MKRGB15(0xff, 0xff, 0xff),
		MKSHORT_YX(((240-8)>>1) + OFFSCREEN_Y() , (368 - 21*8)>>1)
		);
	sendGPU(0x05000000 | 0 | OFFSCREEN_Y() << 10, true);
	TOGGLE_SCREEN();

	cop0_12 = getCop0_12();
	cop0_12 &= ~1;
	cop0_12 = setCop0_12(cop0_12);
	do {
		ChatComms_i();
	} while (CheckComms() == 'i');
	
	setCop0_12(cop0_12);
	
	sendGPU(0x05000000 | 0 | (OFFSCREEN_Y()) << 10, true);
	TOGGLE_SCREEN();
	GPU_sync();
	bogoVSyncWait2(PadBuf, 1);

	return DispMode;
}

/*
 *	j[
 *
 *	WvAB
 *
 *	RETURN
 *	GOTO ADDRESS
 *	SEARCH FOR WORD
 *	ENTER MAIN MENU
 */
static int doFunctions(void)
{
	MENUWIN win;
	MENUDEF menus[] = {
		{ "RETURN", (void *)0 },
		{ "GOTO ADDRESS      >>", (void *)1 },
		{ "SEARCH FOR WORD   >>", (void *)2 },
		{ "BACK TO MAIN MENU", (void *)3 },
		
		{ NULL, NULL },
	};
	RECT rect = { 0, 0, 368, 128 };
	int changed = 0;
	int ret;
	uchar buffer[4];
	ulong addr;
	
	FontPuts("HD for PSX Ver " HD_STRVERSION " by Hanimar",
		MKRGB15(0xff, 0xff, 0xff), MKRGB15(0,0,0),
		MKSHORT_YX(ONSCREEN_Y() + 32, 20)
		);
	MenuWinInit(&win, 30, 64, 160, 64, menus);
	MenuWinRedraw(&win, 0, ONSCREEN_Y());
	GPU_sync();
	
	rect.y = ONSCREEN_Y();
	CopyImage(&rect, 0, OFFSCREEN_Y());
	bogoVSyncWait2(PadBuf, 1);
	sendGPU(0x03000000, true);	/* ʕ\ */

	for (;;) {
		if (changed) {
			changed = 0;
			
			sendGPU(0x05000000 | 0 | (OFFSCREEN_Y()) << 10, true);
			TOGGLE_SCREEN();
			rect.y = ONSCREEN_Y();
			CopyImage(&rect, 0, OFFSCREEN_Y());
			bogoVSyncWait2(PadBuf, 10);
		}
		bogoVSyncWait2(PadBuf, 1);
		if (CheckComms() == 'i') {
			doChat();
			bogoVSyncWait2(PadBuf, 1);
			return FUNCTIONS;	/* d؂蒼 */
		}
		if (PADIS_DOWN(PadBuf)) {
			MenuWinMoveCursor(&win, 1, 0, OFFSCREEN_Y());
			changed ++;
		} else if (PADIS_UP(PadBuf)) {
			MenuWinMoveCursor(&win, -1, 0, OFFSCREEN_Y());
			changed ++;
		} else if (PADIS_CIRCLE(PadBuf)) {
			switch ((int)menus[win.base + win.pos].user) {
			case 0:	/* RETURN */
				ret = DispMode;
				break;
			case 1:
				*(ulong *)buffer = DispAddress;
				ReverseEndian_4(buffer);
				if (InputHex(PadBuf, buffer, 8, 200, ONSCREEN_Y() + 80) == 0) {
					DispAddress = ReverseEndian_4(buffer);
					ret = DispMode;
				} else continue;
				break;
			case 2:
				*(ulong *)buffer = SearchWord;
				if (DispMode == ASSEMBLY) ReverseEndian_4(buffer);
				if (InputHex(PadBuf, buffer, 8, 200, ONSCREEN_Y() + 96) == 0) {
					if (DispMode == ASSEMBLY) SearchWord = ReverseEndian_4(buffer);
					else SearchWord = *(ulong *)buffer;
					ret = DispMode;
					addr = searchNext(SearchWord);
					if (addr != 0xffffffff) DispAddress = addr;
				} else continue;
				break;
			case 3:
				ret = -1;
				break;
			}
			
			break;
		} else if (PADIS_RIGHT(PadBuf)) {
			switch ((int)menus[win.base + win.pos].user) {
			case 1:
				*(ulong *)buffer = DispAddress;
				ReverseEndian_4(buffer);
				if (InputHex(PadBuf, buffer, 8, 200, ONSCREEN_Y() + 80) == 0) {
					DispAddress = ReverseEndian_4(buffer);
					ret = DispMode;
				} else continue;
				break;
			case 2:
				*(ulong *)buffer = SearchWord;
				if (DispMode == ASSEMBLY) ReverseEndian_4(buffer);
				if (InputHex(PadBuf, buffer, 8, 200, ONSCREEN_Y() + 96) == 0) {
					if (DispMode == ASSEMBLY) SearchWord = ReverseEndian_4(buffer);
					else SearchWord = *(ulong *)buffer;
					ret = DispMode;
					addr = searchNext(SearchWord);
					if (addr != 0xffffffff) DispAddress = addr;
				} else continue;
				break;
			default:
				continue;
			}
			break;
		}
	}
	return ret;
}
static ulong searchPrev(ulong word)
{
	ulong addr;
	
	addr = DispAddress;
	do {
		addr = MoveAddr(addr, -4, 4);
		if (*(ulong *)addr == word) return addr;
	} while ((addr & 0x1fffffff) != (DispAddress & 0x1fffffff));
	
	return 0xffffffff;
}

static ulong searchNext(ulong word)
{
	ulong addr;
	
	addr = DispAddress;
	do {
		addr = MoveAddr(addr, 4, 4);
		if (*(ulong *)addr == word) return addr;
	} while ((addr & 0x1fffffff) != (DispAddress & 0x1fffffff));
	
	return 0xffffffff;
}


/*
 *	CvON
 */
static void LoadMain(void)
{
	LoadExec("cdrom:\\psx.exe", 0x801ffff0, 0);
	return;
}

static void InitAll(void)
{
	int pal;
	
	ExitCriticalSection();

	ResetEntryInt();	/* b0 call,t1=0x18 */

	bzero(PadBuf, sizeof (PadBuf));	/* pbḧ揉 */
	InitPAD(PadBuf, sizeof (PadBuf), NULL, 0);
	
	/* GPU */
	sendGPU(0, true);							/* Zbg */
	sendGPU(0x03000001, true);					/* ʕ\ OFF */
	sendGPU(0x06c40240, true);					/* \͈ */
	pal = IS_SCEE();
	sendGPU(0x05000000 | 0 | (pal ? 0:8) << 10, true); 	/* \̈n_ 0,8 */
	
	sendGPU(pal ? 0x07048030 : 0x07040010, true);	/* \͈ */
	/* 368x240 NTSC/PAL 16bit non interlace */
	sendGPU(0x08000000 | 0x40 | ( pal ? 8 : 0 ), true);

	GPU_cw(0xe1000400);	/* `惂[hi\̈ɕ` fBUȂ tpage0j*/
	GPU_cw(0xe3000000);	/* `̈n_ (0,0) */
	GPU_cw(0xe407ffff);	/* `̈I_ (1023,511) */
	GPU_cw(0xe5000000);	/* `ItZbg (0,0) */
	
	ClearScreen(MKRGB24(0,0,0));	/* t[obt@̑| */

	StartPAD();

	return;
}
